<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="style.css">
</head>

<body>

    <h1>PLSQL</h1>
    <h3>Estructura básica</h3>

    <pre>
DECLARE
-- Definición de funciones y variables
<br>        
BEGIN
dbms_output.put_line('Hola Mundo');
<br>
END;
/
</pre>
<hr>
<h3>Comentarios</h3>

--

<hr>
<h3>Impresión de consola</h3>

<pre>
<b>set serveroutput on; </b> // Impresión

DECLARE
--         
BEGIN
dbms_output.put_line('Hola Mundo');
        
END;
/
</pre>
<hr>

<h3>Manejo de Variables</h3>
<p>Se deben de definir primero las variables en "DECLARE"</p>

<pre>
set serveroutput on;
<b>
DECLARE
-- Definición de funciones y variables
salario number := 1500; //Definir y agregar valor
nombreEmpleado nvarchar2(100); //Agregar el tamaño del campo
activo boolean;
fecha date;

BEGIN //Inicializar valor en BEGIN
nombreEmpleado := 'Gabriel';
activo := true;
fecha := sysdate; 

dbms_output.put_line('Nombre Empleado: ' || nombreEmpleado);  // para concatenar ||
dbms_output.put_line('Salario: ' || salario);

dbms_output.put_line('Activo: ' || case when activo then 'Si' else 'No' end);   //Condicion con booleans

END;
/
</b>
</pre>
<hr>

<h3>Constantes</h3>
<p>Dato que no cambia, en mayúscula e inicializar</p>
<pre><b>
DECLARE
-- Constantes
PI CONSTANT NUMBER := 3.1416;
</b>
</pre>

<p>Ejemplo de calcular el área de un círculo y redondear a 2 decimales</p>
<pre><b>
set serveroutput on;

DECLARE
-- Constantes
PI CONSTANT NUMBER := 3.1416;
--Variables
area number;
radio NUMBER;
    
BEGIN
radio := 7;   
area:= pi * (radio * radio);
    
dbms_output.put_line('Radio: ' || round(area,2) || ' cm2');

END;
/
</b></pre>
<hr>

<h3>Valores de un QUERY a variables  (INTO)</h3>

<pre><b>
set serveroutput on;

DECLARE
cantidad number;
usuario nvarchar2(100);

BEGIN

SELECT user INTO usuario FROM dual; //Consulta a la DB con "INTO" se guarda en la variable

dbms_output.put_line('Usuario: ' || usuario);

END;
/
<br>
</b></pre>
<p>INTO con 2 o más valores</p>
<pre><b>
set serveroutput on;

DECLARE
cantidad number;
usuario nvarchar2(100);

BEGIN

SELECT user, COUNT(*) INTO usuario, cantidad FROM dual;

dbms_output.put_line('Usuario: ' || usuario);
dbms_output.put_line('Cantidad: ' || cantidad);
END;
/
</b></pre>
<hr>

<h3>Funciones creadas por Oracle</h3>
<p>Todas las funciones de SQL funcionan igual en PLSQL</p>

<p>Funciones para strings</p>
<ul>
    <li>length</li>
    <li>trim</li>
    <li>lower</li>
    <li>upper</li>
    <li>substr</li>
    <li>replace</li>
</ul>

<p>Funciones para fechas</p>
<ul>
    <li>add_months( , )</li>
    <li> (day + 1) //días</li>
    <li>to_char(hoy, 'dd-MM')</li>
</ul>

<p>Valores nulos NVL</p>
<ul>
    <li>NVL(nombre, 'Es nulo')</li>
</ul>
<hr>

<h3>Arreglos</h3>
*Similares a los Arrays en programación <br>
1. Definimos el arreglo <br>
2. Utilizamos el arreglo <br>

*La primer posición es 1

<pre>
set serveroutput on;

DECLARE
-- Definimos los arreglos
TYPE alumnosArray IS VARRAY(5) OF NVARCHAR2(100);
TYPE notasArray IS VARRAY(5) OF NUMBER;
     
--Utilizamos los arreglos
alumnos alumnosArray;
notas notasArray;
    
BEGIN
     
alumnos := alumnosArray('Gabriel', 'Pedro', 'Juan', 'Jose', 'Maria');
notas := notasArray(10,9,8,9,10);
    
dbms_output.put_line(alumnos(1));
dbms_output.put_line(notas(1));
END;
/    
</pre>

<p>Cambiar el valor de una posición</p>
<pre>
notas(1) := 95;
dbms_output.put_line(notas(1));    
</pre>
<hr>

<h3>Condición  IF-THEN </h3>
<pre>
set serveroutput on;

DECLARE
--
nota number := 69;
    
BEGIN
    
IF (nota = 69) THEN
    
nota := 70; 
        
END IF;    
    
dbms_output.put_line('Nota: ' || nota);
    
END;
/    
</pre>

<h3>Condición IF THEN ELSE</h3>
<pre>
set serveroutput on;

DECLARE
--
nota number := 69;
    
BEGIN
    
IF (nota BETWEEN 67 AND 69) THEN
    
    nota := 70; 
        
END IF;    
    
dbms_output.put_line('Nota: ' || nota);
    
IF (nota >=70) THEN
dbms_output.put_line('Aprobado');
ELSE
dbms_output.put_line('Reprobado');
END IF;
    
END;
/    
</pre>

<h3>Condición IF-THEN-ELSIF</h3>
<pre>
set serveroutput on;

DECLARE
--
nota number := 85;
    
BEGIN
    
IF (nota >=90) THEN
        
    dbms_output.put_line('Excelente');
    
ELSIF (nota >=80) THEN
    
    dbms_output.put_line('Muy bien');
        
ELSIF (nota >=70) THEN
    
    dbms_output.put_line('Bien');
    
ELSE 

    dbms_output.put_line('Reprobado');
        
END IF;    
    
END;
/    
</pre>

<h3>Condicional CASE</h3>
<pre>
set serveroutput on;

DECLARE
--
ran number := round(dbms_random.value(0,5));
    
BEGIN

    dbms_output.put_line(ran);
    
    CASE
        WHEN ran = 0 THEN DBMS_OUTPUT.PUT_LINE('Cero');
        WHEN ran = 1 THEN DBMS_OUTPUT.PUT_LINE('Uno');
        WHEN ran = 2 THEN DBMS_OUTPUT.PUT_LINE('Dos');
        WHEN ran = 3 THEN DBMS_OUTPUT.PUT_LINE('Tres');
        WHEN ran = 4 THEN DBMS_OUTPUT.PUT_LINE('Cuatro');
        ELSE DBMS_OUTPUT.PUT_LINE('Cinco');
    END CASE;
END;
/
</pre>

<hr>

<h3>Operadores de Evaluación</h3>
<pre>
    set serveroutput on;

    DECLARE
    --
    a number := 5;
    b number := 10;
    
    nombre1 nvarchar2(100) := 'Gabriel';
    nombre2 nvarchar2(100);
        
    BEGIN
    
    IF(A = B) THEN
        dbms_output.put_line('iguales');
    END IF;
    
    IF(A <> B) THEN
        dbms_output.put_line('diferentes');
    END IF;
    
    IF(nombre1 LIKE 'G%') THEN
        dbms_output.put_line('G');
    END IF;
    
    IF(a BETWEEN 0 AND 10) THEN
        dbms_output.put_line('Correcto');
    END IF;
    
    IF(b IN (5, 10, 15)) THEN
        dbms_output.put_line('b esta en el grupo de elementos');
    END IF;
    
    IF(nombre2 IS NULL) THEN
        dbms_output.put_line('Es nulo');
    END IF;

    END;
    /
</pre>

<hr>

<h2>Ciclos en PLSQL</h2>
<h3>FOR</h3>

<pre>
    SET SERVEROUTPUT ON;

    DECLARE 
    
    BEGIN
        FOR i IN 1..10 LOOP
            dbms_output.put_line(i);
        END LOOP;
    END;
    /
    
    <hr>

    SET SERVEROUTPUT ON;

DECLARE 

BEGIN

<< ciclo_tabla_2 >>
FOR i IN 1..10 LOOP
    
    dbms_output.put_line(i || ' * 2 = ' || ( i*2 )); -- 1 * 2= 2 //Rotular ciclos for
        
END LOOP ciclo_tabla_2;
END;
/
</pre>



</body>

</html>